/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Core.xs. Do not edit this file, edit Core.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Core.xs"
#ifndef WIN32
#include <unistd.h>
#include <sys/mman.h>
#include <fcntl.h>
#define USE_MMAP
#endif

#include "EXTERN.h"   /* std perl include */
#include "perl.h"     /* std perl include */
#include "XSUB.h"     /* XSUB include */

#if defined(CONTEXT)
#undef CONTEXT
#endif

#include "pdl.h"      /* Data structure declarations */
#define PDL_IN_CORE /* access funcs directly not through PDL-> */
#include "pdlcore.h"  /* Core declarations */

/* Return a integer or numeric scalar as appropriate */

#define setflag(reg,flagval,val) (val?(reg |= flagval):(reg &= ~flagval))

Core PDL; /* Struct holding pointers to shared C routines */

int pdl_debugging=0;
int pdl_autopthread_targ   = 0; /* No auto-pthreading unless set using the set_autopthread_targ */
int pdl_autopthread_actual = 0;
int pdl_autopthread_size   = 1;

#define CHECKP(p)    if ((p) == NULL) croak("Out of memory")

static PDL_Indx* pdl_packint( SV* sv, int *ndims ) {

   SV*  bar;
   AV*  array;
   int i;
   PDL_Indx *dims;

   if (!(SvROK(sv) && SvTYPE(SvRV(sv))==SVt_PVAV))  /* Test */
       return NULL;
   array = (AV *) SvRV(sv);   /* dereference */
     *ndims = (int) av_len(array) + 1;  /* Number of dimensions */
   /* Array space */
   dims = (PDL_Indx *) pdl_smalloc( (*ndims) * sizeof(*dims) );
   CHECKP(dims);

   for(i=0; i<(*ndims); i++) {
      bar = *(av_fetch( array, i, 0 )); /* Fetch */
      dims[i] = (PDL_Indx) SvIV(bar);
   }
   return dims;
}

static SV* pdl_unpackint ( PDL_Indx *dims, int ndims ) {

   AV*  array;
   int i;

   array = newAV();

   for(i=0; i<ndims; i++) /* if ndims == 0, nothing stored -> ok */
         av_store( array, i, newSViv( (IV)dims[i] ) );

   return (SV*) array;
}

/*
 * Free the data if possible; used by mmapper
 * Moved from pdlhash.c July 10 2006 DJB
 */
static void pdl_freedata (pdl *a) {
	if(a->datasv) {
		SvREFCNT_dec(a->datasv);
		a->datasv=0;
		a->data=0;
	} else if(a->data) {
		die("Trying to free data of untouchable (mmapped?) pdl");
	}
}

/* newval = 1 means set flag, 0 means clear it */
/* thanks to Christian Soeller for this */

void pdl_propagate_badflag( pdl *it, int newval ) {
    PDL_DECL_CHILDLOOP(it)
    PDL_START_CHILDLOOP(it)
    {
	pdl_trans *trans = PDL_CHILDLOOP_THISCHILD(it);
	int i;

	for( i = trans->vtable->nparents;
	     i < trans->vtable->npdls; i++ ) {

	    pdl *child = trans->pdls[i];

	    if ( newval ) child->state |=  PDL_BADVAL;
            else          child->state &= ~PDL_BADVAL;

	    /* make sure we propagate to grandchildren, etc */
	    pdl_propagate_badflag( child, newval );

        } /* for: i */
    }
    PDL_END_CHILDLOOP(it)
} /* pdl_propagate_badflag */

void pdl_propagate_badvalue( pdl *it ) {
    PDL_DECL_CHILDLOOP(it)
    PDL_START_CHILDLOOP(it)
    {
	pdl_trans *trans = PDL_CHILDLOOP_THISCHILD(it);
	int i;

	for( i = trans->vtable->nparents;
	     i < trans->vtable->npdls; i++ ) {

	    pdl *child = trans->pdls[i];

            child->has_badvalue = 1;
            child->badvalue = it->badvalue;

	    /* make sure we propagate to grandchildren, etc */
	    pdl_propagate_badvalue( child );

        } /* for: i */
    }
    PDL_END_CHILDLOOP(it)
} /* pdl_propagate_badvalue */


/* this is horrible - the routines from bad should perhaps be here instead ? */
PDL_Anyval pdl_get_badvalue( int datatype ) {
    PDL_Anyval retval = { -1, 0 };
    switch ( datatype ) {

#include "pdldataswitch.c"

      default:
	croak("Unknown type sent to pdl_get_badvalue\n");
    }
    return retval;
} /* pdl_get_badvalue() */


PDL_Anyval pdl_get_pdl_badvalue( pdl *it ) {
    return it->has_badvalue ? it->badvalue : pdl_get_badvalue( it->datatype );
}

#line 160 "Core.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 304 "Core.c"

XS_EUPXS(XS_PDL_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 160 "Core.xs"
    pdl *self;
#line 317 "Core.c"
#line 162 "Core.xs"
    if (  !(  (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVHV) )  ) {
       self = pdl_SvPDLV(sv);
       PDLDEBUG_f(printf("DESTROYING %p\n",(void*)self);)
       if (self != NULL)
          pdl_destroy(self);
    }
#line 325 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_get_trans); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_trans)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	SV *	RETVAL;
#line 175 "Core.xs"
	ST(0) = sv_newmortal();
	if(self->trans)  {
		sv_setref_pv(ST(0), "PDL::Trans", (void*)(self->trans));
	} else {
               ST(0) = &PL_sv_undef;
	}
#line 348 "Core.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_iscontig); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_iscontig)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl*	x = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 186 "Core.xs"
      RETVAL = 1;
      pdl_make_physvaffine( x );
	if PDL_VAFFOK(x) {
	   int i;
           PDL_Indx inc=1;
	   PDLDEBUG_f(printf("vaff check...\n");)
  	   for (i=0;i<x->ndims;i++) {
     	      if (PDL_REPRINC(x,i) != inc) {
		     RETVAL = 0;
		     break;
              }
     	      inc *= x->dims[i];
  	   }
        }
#line 380 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE_COMMAND:  Including output of '/usr/bin/perl -e "require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()"' from 'Core.xs' */


XS_EUPXS(XS_PDL_allocated); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_allocated)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 5 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_ALLOCATED) > 0);
#line 403 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_anychgd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_anychgd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 13 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_ANYCHANGED) > 0);
#line 423 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_bflows); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_bflows)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 21 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_DATAFLOW_B) > 0);
#line 443 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_dimschgd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_dimschgd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 29 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_PARENTDIMSCHANGED) > 0);
#line 463 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_donttouch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_donttouch)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 37 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_DONTTOUCHDATA) > 0);
#line 483 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_fflows); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_fflows)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 45 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_DATAFLOW_F) > 0);
#line 503 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_hdrcpy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_hdrcpy)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "x, mode=0");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
	int	mode;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    mode = 0;
	else {
	    mode = (int)SvIV(ST(1))
;
	}
#line 54 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        if (items>1)
           { setflag(x->state,PDL_HDRCPY,mode); }
        RETVAL = ((x->state & PDL_HDRCPY) > 0);
#line 533 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_is_inplace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_is_inplace)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "x, mode=0");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
	int	mode;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    mode = 0;
	else {
	    mode = (int)SvIV(ST(1))
;
	}
#line 65 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((x->state & PDL_INPLACE) > 0);
        if (items>1)
           { setflag(x->state,PDL_INPLACE,mode); }
#line 563 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_tracedebug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_tracedebug)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "x, mode=0");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
	int	mode;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    mode = 0;
	else {
	    mode = (int)SvIV(ST(1))
;
	}
#line 76 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        if (items>1)
           { setflag(x->state,PDL_TRACEDEBUG,mode); }
        RETVAL = ((x->state & PDL_TRACEDEBUG) > 0);
#line 593 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_vaffine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_vaffine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 86 "/usr/bin/perl -e \"require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()\""
        RETVAL = ((self->state & PDL_OPT_VAFFTRANSOK) > 0);
#line 613 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'Core.xs' from '/usr/bin/perl -e "require q{./Dev.pm}; PDL::Core::Dev::generate_core_flags()"' */

#if 0
#endif /* 0 - commented out */

XS_EUPXS(XS_PDL_set_inplace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_inplace)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	val = (int)SvIV(ST(1))
;
#line 268 "Core.xs"
    setflag(self->state,PDL_INPLACE,val);
#line 638 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_address); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_address)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	IV	RETVAL;
	dXSTARG;
#line 274 "Core.xs"
    RETVAL = PTR2IV(self);
#line 657 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_pdl_hard_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_pdl_hard_copy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "src");
    {
	pdl *	src = PDL_CORE_(SvPDLV)(ST(0))
;
	pdl *	RETVAL;

	RETVAL = pdl_hard_copy(src);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    PDL_CORE_(SetSV_PDL)(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_sever); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_sever)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "src");
    {
	pdl *	src = PDL_CORE_(SvPDLV)(ST(0))
;
	pdl *	RETVAL;
#line 286 "Core.xs"
		if(src->trans) {
			pdl_make_physvaffine(src);
			pdl_destroytransform(src->trans,1);
		}
		RETVAL=src;
#line 703 "Core.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    PDL_CORE_(SetSV_PDL)(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_data_by_mmap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_data_by_mmap)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "it, fname, len, shared, writable, creat, mode, trunc");
    {
	pdl *	it = PDL_CORE_(SvPDLV)(ST(0))
;
	char *	fname = (char *)SvPV_nolen(ST(1))
;
	STRLEN	len = (STRLEN)SvUV(ST(2))
;
	int	writable = (int)SvIV(ST(4))
;
	int	shared = (int)SvIV(ST(3))
;
	int	creat = (int)SvIV(ST(5))
;
	int	mode = (int)SvIV(ST(6))
;
	int	trunc = (int)SvIV(ST(7))
;
	int	RETVAL;
	dXSTARG;
#line 305 "Core.xs"
#ifdef USE_MMAP
       int fd;
       pdl_freedata(it);
       fd = open(fname,(writable && shared ? O_RDWR : O_RDONLY)|
               (creat ? O_CREAT : 0),mode);
       if(fd < 0) {
               croak("Error opening file");
       }
       if(trunc) {
               int error = ftruncate(fd,0);   /* Clear all previous data */

               if(error)
               {
					fprintf(stderr,"Failed to set length of '%s' to %d. errno=%d",fname,(int)len,(int)error);
					croak("set_data_by_mmap: first ftruncate failed");
               }

               error = ftruncate(fd,len); /* And make it long enough */

               if(error)
               {
					fprintf(stderr,"Failed to set length of '%s' to %d. errno=%d",fname,(int)len,(int)error);
					croak("set_data_by_mmap: second ftruncate failed");
               }
       }
       if(len) {
		it->data = mmap(0,len,PROT_READ | (writable ?
					PROT_WRITE : 0),
				(shared ? MAP_SHARED : MAP_PRIVATE),
				fd,0);
		if(!it->data)
			croak("Error mmapping!");
       } else {
               /* Special case: zero-length file */
               it->data = NULL;
       }
       PDLDEBUG_f(printf("PDL::MMap: mapped to %p\n",it->data);)
       it->state |= PDL_DONTTOUCHDATA | PDL_ALLOCATED;
       pdl_add_deletedata_magic(it, pdl_delete_mmapped_data, len);
       close(fd);
#else
	croak("mmap not supported on this architecture");
#endif
       RETVAL = 1;
#line 785 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_state_and_add_deletedata_magic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_state_and_add_deletedata_magic)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "it, len");
    {
	pdl *	it = PDL_CORE_(SvPDLV)(ST(0))
;
	STRLEN	len = (STRLEN)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 357 "Core.xs"
            it->state |= PDL_DONTTOUCHDATA | PDL_ALLOCATED;
            pdl_add_deletedata_magic(it, pdl_delete_mmapped_data, len);
            RETVAL = 1;
#line 809 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_data_by_offset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_data_by_offset)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "it, orig, offset");
    {
	pdl *	it = PDL_CORE_(SvPDLV)(ST(0))
;
	pdl *	orig = PDL_CORE_(SvPDLV)(ST(1))
;
	STRLEN	offset = (STRLEN)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 369 "Core.xs"
              pdl_freedata(it);
              it->data = ((char *) orig->data) + offset;
	      it->datasv = orig->sv;
              (void)SvREFCNT_inc(it->datasv);
              it->state |= PDL_DONTTOUCHDATA | PDL_ALLOCATED;
              RETVAL = 1;
#line 838 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_nelem); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_nelem)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
	PDL_Indx	RETVAL;
	dXSTARG;
#line 382 "Core.xs"
		pdl_make_physdims(x);
		RETVAL = x->nvals;
#line 859 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_howbig_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_howbig_c)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "datatype");
    {
	int	datatype = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 394 "Core.xs"
     RETVAL = pdl_howbig(datatype);
#line 879 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_autopthread_targ); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_autopthread_targ)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "i");
    {
	int	i = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 403 "Core.xs"
	RETVAL = i;
	pdl_autopthread_targ = i;
#line 900 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_get_autopthread_targ); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_autopthread_targ)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 411 "Core.xs"
	RETVAL = pdl_autopthread_targ;
#line 918 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_autopthread_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_autopthread_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "i");
    {
	int	i = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 420 "Core.xs"
	RETVAL = i;
	pdl_autopthread_size = i;
#line 939 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_get_autopthread_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_autopthread_size)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 428 "Core.xs"
	RETVAL = pdl_autopthread_size;
#line 957 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_get_autopthread_actual); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_autopthread_actual)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 435 "Core.xs"
	RETVAL = pdl_autopthread_actual;
#line 975 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__ci); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__ci)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 442 "Core.xs"
  PDL_XS_SCALAR(PDL_CD, PDL_CDouble, 0 + 1I)
#line 993 "Core.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_PDL__nan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__nan)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 447 "Core.xs"
  PDL_XS_SCALAR(PDL_D, PDL_Double, PDL.NaN_double)
#line 1011 "Core.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_PDL__inf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__inf)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 452 "Core.xs"
  PDL_XS_SCALAR(PDL_D, PDL_Double, INFINITY)
#line 1029 "Core.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_PDL__Core_is_scalar_SvPOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_is_scalar_SvPOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "arg");
    {
	SV*	arg = ST(0)
;
	unsigned int	RETVAL;
	dXSTARG;
#line 460 "Core.xs"
	RETVAL = SvPOK(arg);
#line 1049 "Core.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_set_debugging); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_set_debugging)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "i");
    {
	int	i = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 469 "Core.xs"
	RETVAL = pdl_debugging;
	pdl_debugging = i;
#line 1070 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_sclr_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_sclr_c)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "it");
    {
	pdl*	it = PDL_CORE_(SvPDLV)(ST(0))
;
#line 480 "Core.xs"
	PDL_Anyval result = { -1, 0 };
#line 1088 "Core.c"
	SV *	RETVAL;
#line 482 "Core.xs"
        /* get the first element of an ndarray and return as
         * Perl scalar (autodetect suitable type IV or NV)
         */
        result = pdl_at0(it);
        ANYVAL_TO_SV(RETVAL, result);

#line 1097 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_at_bad_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_at_bad_c)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, position");
    {
	pdl*	x = PDL_CORE_(SvPDLV)(ST(0))
;
	SV *	position = ST(1)
;
#line 497 "Core.xs"
    PDL_Indx * pos;
    PDL_Indx npos;
    PDL_Indx ipos;
    int badflag;
    PDL_Anyval result = { -1, 0 };
#line 1122 "Core.c"
	SV *	RETVAL;
#line 503 "Core.xs"
    pdl_make_physvaffine( x );

    pos = pdl_packdims( position, &npos);

    if (pos == NULL || npos < x->ndims)
       croak("Invalid position");

    /*  allow additional trailing indices
     *  which must be all zero, i.e. a
     *  [3,1,5] ndarray is treated as an [3,1,5,1,1,1,....]
     *  infinite dim ndarray
     */
    for (ipos=x->ndims; ipos<npos; ipos++)
      if (pos[ipos] != 0)
         croak("Invalid position");

    result=pdl_at(PDL_REPRP(x), x->datatype, pos, x->dims,
        (PDL_VAFFOK(x) ? x->vafftrans->incs : x->dimincs), PDL_REPROFFS(x),
	x->ndims);
   badflag = (x->state & PDL_BADVAL) > 0;
   if (badflag && ANYVAL_ISBAD(result, x, pdl_get_badvalue(x->datatype)))
     RETVAL = newSVpvn( "BAD", 3 );
   else
     ANYVAL_TO_SV(RETVAL, result);

#line 1150 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_listref_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_listref_c)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
#line 539 "Core.xs"
   PDL_Indx * inds;
   PDL_Indx * incs;
   PDL_Indx offs;
   void *data;
   int ind;
   int lind;
   int stop = 0;
   AV *av;
   SV *sv;
   PDL_Anyval pdl_val =    { -1, 0 };
   PDL_Anyval pdl_badval = { -1, 0 };
#line 1179 "Core.c"
	SV *	RETVAL;
#line 551 "Core.xs"
    /*
    */

   int badflag = (x->state & PDL_BADVAL) > 0;
   if (badflag) {
      pdl_badval = pdl_get_pdl_badvalue( x );
   }

   pdl_make_physvaffine( x );
   inds = pdl_smalloc(sizeof(PDL_Indx) * x->ndims); /* GCC -> on stack :( */
   data = PDL_REPRP(x);
   incs = (PDL_VAFFOK(x) ? x->vafftrans->incs : x->dimincs);
   offs = PDL_REPROFFS(x);
   av = newAV();
   av_extend(av,x->nvals);
   lind=0;
   for(ind=0; ind < x->ndims; ind++) inds[ind] = 0;
   while(!stop) {
      pdl_val = pdl_at( data, x->datatype, inds, x->dims, incs, offs, x->ndims );
      if (badflag && ANYVAL_ISBAD(pdl_val, x, pdl_badval)) {
	 sv = newSVpvn( "BAD", 3 );
      } else {
	 ANYVAL_TO_SV(sv, pdl_val);
      }
      av_store( av, lind, sv );

      lind++;
      stop = 1;
      for(ind = 0; ind < x->ndims; ind++) {
	 if(++(inds[ind]) >= x->dims[ind]) {
       	    inds[ind] = 0;
         } else {
       	    stop = 0; break;
         }
      }
   }
   RETVAL = newRV_noinc((SV *)av);
#line 1219 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_set_c); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_set_c)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "x, position, value");
    {
	pdl*	x = PDL_CORE_(SvPDLV)(ST(0))
;
	SV*	position = ST(1)
;
	PDL_Anyval	value;
#line 600 "Core.xs"
    PDL_Indx * pos;
    PDL_Indx npos;
    PDL_Indx ipos;
#line 1243 "Core.c"

	ANYVAL_FROM_SV(value, ST(2), FALSE, -1)
;
#line 604 "Core.xs"
    pdl_make_physvaffine( x );

    pos = pdl_packdims( position, &npos);
    if (pos == NULL || npos < x->ndims)
       croak("Invalid position");

    /*  allow additional trailing indices
     *  which must be all zero, i.e. a
     *  [3,1,5] ndarray is treated as an [3,1,5,1,1,1,....]
     *  infinite dim ndarray
     */
    for (ipos=x->ndims; ipos<npos; ipos++)
      if (pos[ipos] != 0)
         croak("Invalid position");

    pdl_children_changesoon( x , PDL_PARENTDATACHANGED );
    pdl_set(PDL_REPRP(x), x->datatype, pos, x->dims,
        (PDL_VAFFOK(x) ? x->vafftrans->incs : x->dimincs), PDL_REPROFFS(x),
	x->ndims,value);
    if (PDL_VAFFOK(x))
       pdl_vaffinechanged(x, PDL_PARENTDATACHANGED);
    else
       pdl_changed( x , PDL_PARENTDATACHANGED , 0 );
#line 1271 "Core.c"
    }
    XSRETURN_EMPTY;
}

#define PDL_CORE_BOOT(sym) PDL.sym = pdl_ ## sym;

XS_EUPXS(XS_PDL__Core_pdl_avref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_pdl_avref)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "array_ref, class, type");
    {
	SV*	array_ref = ST(0)
;
	char*	class = (char *)SvPV_nolen(ST(1))
;
	int	type = (int)SvIV(ST(2))
;
#line 718 "Core.xs"
     AV *dims, *av;
     int i, depth;
     int datalevel = -1;
     SV* psv;
     pdl* p;
#line 1297 "Core.c"
	SV *	RETVAL;
#line 724 "Core.xs"
     /* make an ndarray from a Perl array ref */

     if (!SvROK(array_ref))
       croak("pdl_avref: not a reference");


     if (SvTYPE(SvRV(array_ref)) != SVt_PVAV)
       croak("pdl_avref: not an array reference");

     // Expand the array ref to a list, and allocate a Perl list to hold the dimlist
     av = (AV *) SvRV(array_ref);
     dims = (AV *) sv_2mortal( (SV *) newAV());

     av_store(dims,0,newSViv((IV) av_len(av)+1));

     /* even if we contain nothing depth is one */
     depth = 1 + av_ndcheck(av,dims,0,&datalevel);

     /* printf("will make type %s\n",class); */
     /*
	at this stage start making an ndarray and populate it with
	values from the array (which has already been checked in av_check)
     */
     if (strcmp(class,"PDL") == 0) {
        p = pdl_from_array(av,dims,type,NULL); /* populate with data */
        ST(0) = sv_newmortal();
        pdl_SetSV_PDL(ST(0),p);
     } else {
       /* call class->initialize method */
       PUSHMARK(SP);
       XPUSHs(sv_2mortal(newSVpv(class, 0)));
       PUTBACK;
       perl_call_method("initialize", G_SCALAR);
       SPAGAIN;
       psv = POPs;
       PUTBACK;
       p = pdl_SvPDLV(psv); /* and get ndarray from returned object */
       ST(0) = psv;
       pdl_from_array(av,dims,type,p); /* populate ;) */
     }
#line 1340 "Core.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_pdl_null); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_pdl_null)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
	pdl *	RETVAL;

	RETVAL = pdl_null();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    PDL_CORE_(SetSV_PDL)(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL__Core_pthreads_enabled); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL__Core_pthreads_enabled)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = pdl_pthreads_enabled();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_isnull); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_isnull)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 786 "Core.xs"
		RETVAL= !!(self->state & PDL_NOMYDIMS);
#line 1397 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_make_physical); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_make_physical)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	pdl *	RETVAL;
#line 794 "Core.xs"
		pdl_make_physical(self);
		RETVAL = self;
#line 1417 "Core.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    PDL_CORE_(SetSV_PDL)(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_make_physvaffine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_make_physvaffine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	pdl *	RETVAL;
#line 803 "Core.xs"
		pdl_make_physvaffine(self);
		RETVAL = self;
#line 1442 "Core.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    PDL_CORE_(SetSV_PDL)(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_make_physdims); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_make_physdims)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	pdl *	RETVAL;
#line 813 "Core.xs"
		pdl_make_physdims(self);
		RETVAL = self;
#line 1467 "Core.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    PDL_CORE_(SetSV_PDL)(RETVALSV,RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_dump)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;

	pdl_dump(x);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_add_threading_magic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_add_threading_magic)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "it, nthdim, nthreads");
    {
	pdl *	it = PDL_CORE_(SvPDLV)(ST(0))
;
	int	nthdim = (int)SvIV(ST(1))
;
	int	nthreads = (int)SvIV(ST(2))
;

	pdl_add_threading_magic(it, nthdim, nthreads);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_remove_threading_magic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_remove_threading_magic)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "it");
    {
	pdl *	it = PDL_CORE_(SvPDLV)(ST(0))
;
#line 832 "Core.xs"
		pdl_add_threading_magic(it,-1,-1);
#line 1526 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_initialize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_initialize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	class = ST(0)
;
#line 840 "Core.xs"
	HV *bless_stash;
#line 1545 "Core.c"
	SV *	RETVAL;
#line 842 "Core.xs"
        if (SvROK(class)) { /* a reference to a class */
	  bless_stash = SvSTASH(SvRV(class));
        } else {            /* a class name */
          bless_stash = gv_stashsv(class, 0);
        }
        ST(0) = sv_newmortal();
        pdl_SetSV_PDL(ST(0),pdl_null());   /* set a null PDL to this SV * */
        ST(0) = sv_bless(ST(0), bless_stash); /* bless appropriately  */
	XSRETURN(1);
#line 1557 "Core.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_PDL_get_dataref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_dataref)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	SV *	RETVAL;
#line 856 "Core.xs"
	if(self->state & PDL_DONTTOUCHDATA) {
		croak("Trying to get dataref to magical (mmaped?) pdl");
	}
	pdl_make_physical(self); /* XXX IS THIS MEMLEAK WITHOUT MORTAL? */
	RETVAL = (newRV(self->datasv));
#line 1580 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_get_datatype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_get_datatype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 868 "Core.xs"
	RETVAL = self->datatype;
#line 1601 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_upd_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_upd_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
#line 876 "Core.xs"
       STRLEN n_a;
#line 1619 "Core.c"
	int	RETVAL;
	dXSTARG;
#line 878 "Core.xs"
	if(self->state & PDL_DONTTOUCHDATA) {
		croak("Trying to touch dataref of magical (mmaped?) pdl");
	}
       self->data = SvPV((SV*)self->datasv,n_a);
	XSRETURN(0);
#line 1628 "Core.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_dataflow_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_dataflow_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, value");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	value = (int)SvIV(ST(1))
;
#line 889 "Core.xs"
	if(value)
		self->state |= PDL_DATAFLOW_F;
	else
		self->state &= ~PDL_DATAFLOW_F;
#line 1650 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_set_dataflow_b); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_dataflow_b)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, value");
    {
	pdl *	self = PDL_CORE_(SvPDLV)(ST(0))
;
	int	value = (int)SvIV(ST(1))
;
#line 899 "Core.xs"
	if(value)
		self->state |= PDL_DATAFLOW_B;
	else
		self->state &= ~PDL_DATAFLOW_B;
#line 1672 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_getndims); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_getndims)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 910 "Core.xs"
		pdl_make_physdims(x);
		RETVAL = x->ndims;
#line 1693 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_getdim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_getdim)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "x, y");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
	int	y = (int)SvIV(ST(1))
;
	PDL_Indx	RETVAL;
	dXSTARG;
#line 922 "Core.xs"
		pdl_make_physdims(x);
		if (y < 0) y = x->ndims + y;
		if (y < 0) croak("negative dim index too large");
		if (y < x->ndims)
                   RETVAL = x->dims[y];
                else
		   RETVAL = 1; /* return size 1 for all other dims */
#line 1722 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_getnthreadids); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_getnthreadids)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 936 "Core.xs"
		pdl_make_physdims(x);
		RETVAL = x->nthreadids;
#line 1743 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_getthreadid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_getthreadid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, y");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
	int	y = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 946 "Core.xs"
		RETVAL = x->threadids[y];
#line 1765 "Core.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_setdims); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_setdims)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, dims_arg");
    {
	pdl *	x = PDL_CORE_(SvPDLV)(ST(0))
;
	SV *	dims_arg = ST(1)
;
#line 955 "Core.xs"
	 PDL_Indx * dims;
	 PDL_Indx ndims;
       int i;
#line 1787 "Core.c"
#line 959 "Core.xs"
	{
	        /* This mask avoids all kinds of subtle dereferencing bugs (CED 11/2015) */
	        if(x->trans || x->vafftrans || x->children.next ) {
		  pdl_pdl_barf("Can't setdims on a PDL that already has children");
		}

		/* not sure if this is still necessary with the mask above... (CED 11/2015)  */
		pdl_children_changesoon(x,PDL_PARENTDIMSCHANGED|PDL_PARENTDATACHANGED);
		dims = pdl_packdims(dims_arg,&ndims);
		pdl_reallocdims(x,ndims);
		for(i=0; i<ndims; i++) x->dims[i] = dims[i];
		pdl_resize_defaultincs(x);
		x->threadids[0] = ndims;
		x->state &= ~PDL_NOMYDIMS;
		pdl_changed(x,PDL_PARENTDIMSCHANGED|PDL_PARENTDATACHANGED,0);
	}
#line 1805 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_dowhenidle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_dowhenidle)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 979 "Core.xs"
		pdl_run_delayed_magic();
		XSRETURN(0);
#line 1821 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_bind)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, c");
    {
	pdl *	p = PDL_CORE_(SvPDLV)(ST(0))
;
	SV *	c = ST(1)
;
#line 988 "Core.xs"
		pdl_add_svmagic(p,c);
		XSRETURN(0);
#line 1841 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_sethdr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_sethdr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, h");
    {
	pdl *	p = PDL_CORE_(SvPDLV)(ST(0))
;
	SV *	h = ST(1)
;
#line 996 "Core.xs"
	HV* hash;
#line 1860 "Core.c"
#line 998 "Core.xs"
		if(p->hdrsv == NULL) {
		      p->hdrsv =  &PL_sv_undef; /*(void*) newSViv(0);*/
		}

		/* Throw an error if we're not either undef or hash */
                if ( (h != &PL_sv_undef && h != NULL) &&
		     ( !SvROK(h) || SvTYPE(SvRV(h)) != SVt_PVHV )
		   )
		      croak("Not a HASH reference");

		/* Clear the old header */
		SvREFCNT_dec(p->hdrsv);

		/* Put the new header (or undef) in place */
		if(h == &PL_sv_undef || h == NULL)
		   p->hdrsv = NULL;
		else
		   p->hdrsv = (void*) newRV( (SV*) SvRV(h) );
#line 1880 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_hdr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_hdr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	pdl *	p = PDL_CORE_(SvPDLV)(ST(0))
;
	SV *	RETVAL;
#line 1021 "Core.xs"
		pdl_make_physdims(p);

                /* Make sure that in the undef case we return not */
                /* undef but an empty hash ref. */

                if((p->hdrsv==NULL) || (p->hdrsv == &PL_sv_undef)) {
	            p->hdrsv = (void*) newRV_noinc( (SV*)newHV() );
                }

		RETVAL = newRV( (SV*) SvRV((SV*)p->hdrsv) );

#line 1908 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_gethdr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_gethdr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	pdl *	p = PDL_CORE_(SvPDLV)(ST(0))
;
	SV *	RETVAL;
#line 1043 "Core.xs"
		pdl_make_physdims(p);

                if((p->hdrsv==NULL) || (p->hdrsv == &PL_sv_undef)) {
	            RETVAL = &PL_sv_undef;
                } else {
		    RETVAL = newRV( (SV*) SvRV((SV*)p->hdrsv) );
                }

#line 1935 "Core.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_PDL_set_datatype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_set_datatype)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, datatype");
    {
	pdl *	a = PDL_CORE_(SvPDLV)(ST(0))
;
	int	datatype = (int)SvIV(ST(1))
;
#line 1059 "Core.xs"
    pdl_make_physical(a);
    if(a->trans)
	    pdl_destroytransform(a->trans,1);
/*     if(! (a->state && PDL_NOMYDIMS)) { */
    pdl_converttype( &a, datatype, PDL_PERM );
/*     } */
#line 1961 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_threadover_n); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_threadover_n)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 1069 "Core.xs"
   int npdls;
   SV *sv;
#line 1977 "Core.c"
#line 1072 "Core.xs"
   {
    npdls = items - 1;
    if(npdls <= 0)
    	croak("Usage: threadover_n(pdl[,pdl...],sub)");
    {
	    int i,sd;
	    pdl **pdls = malloc(sizeof(pdl *) * npdls);
	    PDL_Indx *realdims = malloc(sizeof(PDL_Indx) * npdls);
	    pdl_thread pdl_thr;
	    SV *code = ST(items-1);
	    for(i=0; i<npdls; i++) {
		pdls[i] = pdl_SvPDLV(ST(i));
		/* XXXXXXXX Bad */
		pdl_make_physical(pdls[i]);
		realdims[i] = 0;
	    }
	    PDL_THR_CLRMAGIC(&pdl_thr);
	    pdl_initthreadstruct(0,pdls,realdims,realdims,npdls,NULL,&pdl_thr,NULL, 1);
	    pdl_startthreadloop(&pdl_thr,NULL,NULL);
	    sd = pdl_thr.ndims;
	    do {
	    	dSP;
		PUSHMARK(sp);
		EXTEND(sp,items);
		PUSHs(sv_2mortal(newSViv((sd-1))));
		for(i=0; i<npdls; i++) {
			PDL_Anyval pdl_val = { -1, 0 };
			pdl_val = pdl_get_offs(pdls[i],pdl_thr.offs[i]);
			ANYVAL_TO_SV(sv, pdl_val);
			PUSHs(sv_2mortal(sv));
		}
	    	PUTBACK;
		perl_call_sv(code,G_DISCARD);
	    } while( (sd = pdl_iterthreadloop(&pdl_thr,0)) );
	    pdl_freethreadloop(&pdl_thr);
	    free(pdls);
	    free(realdims);
    }
   }
#line 2018 "Core.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_PDL_threadover); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_PDL_threadover)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 1115 "Core.xs"
    int npdls;
    int targs;
    int nothers = -1;
#line 2035 "Core.c"
#line 1119 "Core.xs"
   {
        targs = items - 4;
    if (items > 0) nothers = SvIV(ST(0));
    if(targs <= 0 || nothers < 0 || nothers >= targs)
    	croak("Usage: threadover(nothers,pdl[,pdl...][,otherpars..],realdims,creating,sub)");
    npdls = targs-nothers;
    {
	    int i,nd1,nd2,dtype=0;
	    PDL_Indx j,nc=npdls;
	    SV* rdimslist = ST(items-3);
	    SV* cdimslist = ST(items-2);
	    SV *code = ST(items-1);
	    pdl_thread pdl_thr;
	    pdl **pdls = malloc(sizeof(pdl *) * npdls);
	    pdl **child = malloc(sizeof(pdl *) * npdls);
	    SV **csv = malloc(sizeof(SV *) * npdls);
	    SV **dims = malloc(sizeof(SV *) * npdls);
	    SV **incs = malloc(sizeof(SV *) * npdls);
	    SV **others = malloc(sizeof(SV *) * nothers);
	    PDL_Indx *creating = pdl_packint(cdimslist,&nd2);
	    PDL_Indx *realdims = pdl_packint(rdimslist,&nd1);
	    CHECKP(pdls); CHECKP(child); CHECKP(dims);
	    CHECKP(incs); CHECKP(csv);

	    if (nd1 != npdls || nd2 < npdls)
		croak("threadover: need one realdim and creating flag "
		      "per pdl!");
	    for(i=0; i<npdls; i++) {
		pdls[i] = pdl_SvPDLV(ST(i+1));
		if (creating[i])
		  nc += realdims[i];
		else {
		  pdl_make_physical(pdls[i]); /* is this what we want?XXX */
		  dtype = PDLMAX(dtype,pdls[i]->datatype);
		}
	    }
	    for (i=npdls+1; i<=targs; i++)
		others[i-npdls-1] = ST(i);
	    if (nd2 < nc)
		croak("Not enough dimension info to create pdls");
#ifdef DEBUG_PTHREAD
		for (i=0;i<npdls;i++) { /* just for debugging purposes */
		printf("pdl %d Dims: [",i);
		for (j=0;j<realdims[i];j++)
			printf("%d ",pdls[i]->dims[j]);
		printf("] Incs: [");
		for (j=0;j<realdims[i];j++)
			printf("%d ",PDL_REPRINC(pdls[i],j));
		printf("]\n");
	        }
#endif
	    PDL_THR_CLRMAGIC(&pdl_thr);
	    pdl_initthreadstruct(0,pdls,realdims,creating,npdls,
				NULL,&pdl_thr,NULL, 1);
	    for(i=0, nc=npdls; i<npdls; i++)  /* create as necessary */
              if (creating[i]) {
		PDL_Indx *cp = creating+nc;
		pdls[i]->datatype = dtype;
		pdl_thread_create_parameter(&pdl_thr,i,cp,0);
		nc += realdims[i];
		pdl_make_physical(pdls[i]);
		PDLDEBUG_f(pdl_dump(pdls[i]));
		/* And make it nonnull, now that we've created it */
		pdls[i]->state &= (~PDL_NOMYDIMS);
	      }
	    pdl_startthreadloop(&pdl_thr,NULL,NULL);
	    for(i=0; i<npdls; i++) { /* will the SV*'s be properly freed? */
		dims[i] = newRV(pdl_unpackint(pdls[i]->dims,realdims[i]));
		incs[i] = newRV(pdl_unpackint(PDL_VAFFOK(pdls[i]) ?
		pdls[i]->vafftrans->incs: pdls[i]->dimincs,realdims[i]));
		/* need to make sure we get the vaffine (grand)parent */
		if (PDL_VAFFOK(pdls[i]))
		   pdls[i] = pdls[i]->vafftrans->from;
		child[i]=pdl_null();
		/*  instead of pdls[i] its vaffine parent !!!XXX */
		PDL.affine_new(pdls[i],child[i],pdl_thr.offs[i],dims[i],
						incs[i]);
		pdl_make_physical(child[i]); /* make sure we can get at
						the vafftrans          */
		csv[i] = sv_newmortal();
		pdl_SetSV_PDL(csv[i], child[i]); /* pdl* into SV* */
	    }
	    do {  /* the actual threadloop */
		pdl_trans_affine *traff;
	    	dSP;
		PUSHMARK(sp);
		EXTEND(sp,npdls);
		for(i=0; i<npdls; i++) {
		   /* just twiddle the offset - quick and dirty */
		   /* we must twiddle both !! */
		   traff = (pdl_trans_affine *) child[i]->trans;
		   traff->offs = pdl_thr.offs[i];
		   child[i]->vafftrans->offs = pdl_thr.offs[i];
		   child[i]->state |= PDL_PARENTDATACHANGED;
		   PUSHs(csv[i]);
		}
		for (i=0; i<nothers; i++)
		  PUSHs(others[i]);   /* pass the OtherArgs onto the stack */
	    	PUTBACK;
		perl_call_sv(code,G_DISCARD);
	    } while (pdl_iterthreadloop(&pdl_thr,0));
	    pdl_freethreadloop(&pdl_thr);
	    free(pdls);  /* should all these be done with pdl_smalloc */
	    free(dims);  /* in case the sub barfs ? XXXX            */
	    free(child);
	    free(csv);
	    free(incs);
	    free(others);
    }
   }
#line 2147 "Core.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_PDL__Core); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_PDL__Core)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("PDL::DESTROY", XS_PDL_DESTROY);
        newXS_deffile("PDL::get_trans", XS_PDL_get_trans);
        newXS_deffile("PDL::iscontig", XS_PDL_iscontig);
        newXS_deffile("PDL::allocated", XS_PDL_allocated);
        newXS_deffile("PDL::anychgd", XS_PDL_anychgd);
        newXS_deffile("PDL::bflows", XS_PDL_bflows);
        newXS_deffile("PDL::dimschgd", XS_PDL_dimschgd);
        newXS_deffile("PDL::donttouch", XS_PDL_donttouch);
        newXS_deffile("PDL::fflows", XS_PDL_fflows);
        newXS_deffile("PDL::hdrcpy", XS_PDL_hdrcpy);
        newXS_deffile("PDL::is_inplace", XS_PDL_is_inplace);
        newXS_deffile("PDL::tracedebug", XS_PDL_tracedebug);
        newXS_deffile("PDL::vaffine", XS_PDL_vaffine);
        newXS_deffile("PDL::set_inplace", XS_PDL_set_inplace);
        newXS_deffile("PDL::address", XS_PDL_address);
        newXS_deffile("PDL::pdl_hard_copy", XS_PDL_pdl_hard_copy);
        newXS_deffile("PDL::sever", XS_PDL_sever);
        newXS_deffile("PDL::set_data_by_mmap", XS_PDL_set_data_by_mmap);
        newXS_deffile("PDL::set_state_and_add_deletedata_magic", XS_PDL_set_state_and_add_deletedata_magic);
        newXS_deffile("PDL::set_data_by_offset", XS_PDL_set_data_by_offset);
        newXS_deffile("PDL::nelem", XS_PDL_nelem);
        newXS_deffile("PDL::howbig_c", XS_PDL_howbig_c);
        newXS_deffile("PDL::set_autopthread_targ", XS_PDL_set_autopthread_targ);
        newXS_deffile("PDL::get_autopthread_targ", XS_PDL_get_autopthread_targ);
        newXS_deffile("PDL::set_autopthread_size", XS_PDL_set_autopthread_size);
        newXS_deffile("PDL::get_autopthread_size", XS_PDL_get_autopthread_size);
        newXS_deffile("PDL::get_autopthread_actual", XS_PDL_get_autopthread_actual);
        newXS_deffile("PDL::_ci", XS_PDL__ci);
        newXS_deffile("PDL::_nan", XS_PDL__nan);
        newXS_deffile("PDL::_inf", XS_PDL__inf);
        newXS_deffile("PDL::Core::is_scalar_SvPOK", XS_PDL__Core_is_scalar_SvPOK);
        newXS_deffile("PDL::Core::set_debugging", XS_PDL__Core_set_debugging);
        newXS_deffile("PDL::Core::sclr_c", XS_PDL__Core_sclr_c);
        newXS_deffile("PDL::Core::at_bad_c", XS_PDL__Core_at_bad_c);
        newXS_deffile("PDL::Core::listref_c", XS_PDL__Core_listref_c);
        newXS_deffile("PDL::Core::set_c", XS_PDL__Core_set_c);
        newXS_deffile("PDL::Core::pdl_avref", XS_PDL__Core_pdl_avref);
        newXS_deffile("PDL::pdl_null", XS_PDL_pdl_null);
        newXS_deffile("PDL::Core::pthreads_enabled", XS_PDL__Core_pthreads_enabled);
        newXS_deffile("PDL::isnull", XS_PDL_isnull);
        newXS_deffile("PDL::make_physical", XS_PDL_make_physical);
        newXS_deffile("PDL::make_physvaffine", XS_PDL_make_physvaffine);
        newXS_deffile("PDL::make_physdims", XS_PDL_make_physdims);
        newXS_deffile("PDL::dump", XS_PDL_dump);
        newXS_deffile("PDL::add_threading_magic", XS_PDL_add_threading_magic);
        newXS_deffile("PDL::remove_threading_magic", XS_PDL_remove_threading_magic);
        newXS_deffile("PDL::initialize", XS_PDL_initialize);
        newXS_deffile("PDL::get_dataref", XS_PDL_get_dataref);
        newXS_deffile("PDL::get_datatype", XS_PDL_get_datatype);
        newXS_deffile("PDL::upd_data", XS_PDL_upd_data);
        newXS_deffile("PDL::set_dataflow_f", XS_PDL_set_dataflow_f);
        newXS_deffile("PDL::set_dataflow_b", XS_PDL_set_dataflow_b);
        cv = newXS_deffile("PDL::getndims", XS_PDL_getndims);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("PDL::ndims", XS_PDL_getndims);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("PDL::dim", XS_PDL_getdim);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("PDL::getdim", XS_PDL_getdim);
        XSANY.any_i32 = 0;
        newXS_deffile("PDL::getnthreadids", XS_PDL_getnthreadids);
        newXS_deffile("PDL::getthreadid", XS_PDL_getthreadid);
        newXS_deffile("PDL::setdims", XS_PDL_setdims);
        newXS_deffile("PDL::dowhenidle", XS_PDL_dowhenidle);
        (void)newXSproto_portable("PDL::bind", XS_PDL_bind, file, "$&");
        newXS_deffile("PDL::sethdr", XS_PDL_sethdr);
        newXS_deffile("PDL::hdr", XS_PDL_hdr);
        newXS_deffile("PDL::gethdr", XS_PDL_gethdr);
        newXS_deffile("PDL::set_datatype", XS_PDL_set_datatype);
        newXS_deffile("PDL::threadover_n", XS_PDL_threadover_n);
        newXS_deffile("PDL::threadover", XS_PDL_threadover);

    /* Initialisation Section */

#line 631 "Core.xs"
{
#if NVSIZE > 8
   fprintf(stderr, "Your perl NV has more precision than PDL_Double.  There will be loss of floating point precision!\n");
#endif

   /* Initialize structure of pointers to core C routines */

   PDL.Version     = PDL_CORE_VERSION;
   PDL_CORE_BOOT(SvPDLV)
   PDL_CORE_BOOT(SetSV_PDL)
   PDL_CORE_BOOT(create)
   PDL_CORE_BOOT(pdlnew)
   PDL.tmp         = NULL; /* only here for binary back-compat */
   PDL_CORE_BOOT(destroy)
   PDL_CORE_BOOT(null)
   PDL_CORE_BOOT(copy)
   PDL_CORE_BOOT(hard_copy)
   PDL_CORE_BOOT(converttype)
   PDL_CORE_BOOT(twod)
   PDL_CORE_BOOT(smalloc)
   PDL_CORE_BOOT(howbig)
   PDL_CORE_BOOT(packdims)
   PDL_CORE_BOOT(unpackdims)
   PDL_CORE_BOOT(setdims)
   PDL_CORE_BOOT(grow)
   PDL_CORE_BOOT(at0)
   PDL.flushcache  = NULL;
   PDL_CORE_BOOT(reallocdims)
   PDL_CORE_BOOT(reallocthreadids)
   PDL_CORE_BOOT(resize_defaultincs)
   PDL_CORE_BOOT(get_threadoffsp)
   PDL_CORE_BOOT(thread_copy)
   PDL_CORE_BOOT(clearthreadstruct)
   PDL_CORE_BOOT(initthreadstruct)
   PDL_CORE_BOOT(startthreadloop)
   PDL_CORE_BOOT(iterthreadloop)
   PDL_CORE_BOOT(freethreadloop)
   PDL_CORE_BOOT(thread_create_parameter)
   PDL_CORE_BOOT(add_deletedata_magic)

   PDL_CORE_BOOT(setdims_careful)
   PDL_CORE_BOOT(put_offs)
   PDL_CORE_BOOT(get_offs)
   PDL_CORE_BOOT(get)
   PDL_CORE_BOOT(set_trans_childtrans)
   PDL_CORE_BOOT(set_trans_parenttrans)

   PDL_CORE_BOOT(get_convertedpdl)

   PDL_CORE_BOOT(make_trans_mutual)
   PDL_CORE_BOOT(trans_mallocfreeproc)
   PDL_CORE_BOOT(make_physical)
   PDL_CORE_BOOT(make_physdims)
   PDL_CORE_BOOT(make_physvaffine)
   PDL_CORE_BOOT(pdl_barf)
   PDL_CORE_BOOT(pdl_warn)
   PDL_CORE_BOOT(allocdata)
   PDL_CORE_BOOT(safe_indterm)
   PDL_CORE_BOOT(children_changesoon)
   PDL_CORE_BOOT(changed)
   PDL_CORE_BOOT(vaffinechanged)

   PDL.NaN_float  = union_nan_float.f;
   PDL.NaN_double = union_nan_double.d;
   PDL.NaN_cfloat  = union_nan_float.f + I*union_nan_float.f;
   PDL.NaN_cdouble = union_nan_double.d + I*union_nan_double.d;
   PDL_CORE_BOOT(propagate_badflag)
   PDL_CORE_BOOT(propagate_badvalue)
   PDL_CORE_BOOT(get_pdl_badvalue)
#include "pdlbadvalinit.c"
   /*
      "Publish" pointer to this structure in perl variable for use
       by other modules
   */
   sv_setiv(get_sv("PDL::SHARE",TRUE|GV_ADDMULTI), PTR2IV(&PDL));
}

#line 2332 "Core.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

